package com.wifioferta;

import java.util.ArrayList;
import java.util.List;

import com.wifioferta.R;
import com.wifioferta.BuyListFragment.BuyActionListener;


import android.app.Fragment;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;

/*
* Fragment showing selected buy offer
* makes it possible to edit or delete
*/
public class BuyDetailFragment extends Fragment {
  private View mContentView;
  private Buy oldDevice;
  private Buy newDevice;
  private ArrayAdapter<String> dataAdapter;
  private ArrayAdapter<Boolean> activeAdapter;
  @Override
  public void onActivityCreated(Bundle savedInstanceState) {
    super.onActivityCreated(savedInstanceState);
  }

  @Override
  public View onCreateView(LayoutInflater inflater, ViewGroup container,
      Bundle savedInstanceState) {

    mContentView = inflater.inflate(R.layout.buy_detail, null);

    mContentView.findViewById(R.id.btn_connect).setOnClickListener(
        new View.OnClickListener() {

          @Override
          public void onClick(View v) {

            if (newDevice == null) {
              newDevice = new Buy();
            }
            EditText view = (EditText) mContentView
                .findViewById(R.id.buy_price);
            try {
              newDevice.setPrice(Double.parseDouble(view.getText().toString()));
              view = (EditText) mContentView.findViewById(R.id.buy_param1);
              newDevice.setParam1(Double.parseDouble(view.getText().toString()));

            } catch (NumberFormatException e) {
            }
            view = (EditText) mContentView.findViewById(R.id.buy_param2);
            newDevice.setParam2(view.getText().toString());
            view = (EditText) mContentView.findViewById(R.id.buy_title);
            newDevice.setTittle(view.getText().toString());
            view = (EditText) mContentView.findViewById(R.id.buy_desc);
            newDevice.setDescription(view.getText().toString());
            newDevice.setCodedName();

            ((BuyActionListener) getActivity()).editOffer(oldDevice, newDevice);
            mContentView.setVisibility(View.GONE);
          }
        });

    mContentView.findViewById(R.id.btn_disconnect).setOnClickListener(
        new View.OnClickListener() {

          @Override
          public void onClick(View v) {
            ((BuyActionListener) getActivity()).deleteOffer(oldDevice);
            mContentView.setVisibility(View.GONE);
          }
        });

    return mContentView;
  }

  public void showDetails(Buy offer) {
    this.oldDevice = offer;
    this.newDevice = new Buy();
    this.getView().setVisibility(View.VISIBLE);
    if (oldDevice == null)
      oldDevice = new Buy();

    Spinner cat = (Spinner) mContentView.findViewById(R.id.buy_category);
    List<String> list = new ArrayList<String>();
    final OffersManagerActivity activity = (OffersManagerActivity) getActivity();
    for (Category category : activity.getCategories()) {
      list.add(category.getName());
    }

    dataAdapter = new ArrayAdapter<String>(getActivity(),
        android.R.layout.simple_spinner_item, list);
    dataAdapter
        .setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
    cat.setAdapter(dataAdapter);

    int i = dataAdapter.getPosition(oldDevice.getCategory().getName());
    if (i != 1)
      i = 0;
    cat.setSelection(i);

    TextView view = (TextView) mContentView.findViewById(R.id.buy_par1);
    view.setText(activity.getCategories().get(i).getParam1());
    view = (TextView) mContentView.findViewById(R.id.buy_par2);
    view.setText(activity.getCategories().get(i).getParam2());
    cat.setOnItemSelectedListener(new OnItemSelectedListener() {

      @Override
      public void onItemSelected(AdapterView<?> adapter, View v, int pos,
          long value) {
        newDevice.setCategory(activity.getCategories().get(pos));
        TextView view = (TextView) mContentView.findViewById(R.id.buy_par1);
        view.setText(activity.getCategories().get(pos).getParam1());
        view = (TextView) mContentView.findViewById(R.id.buy_par2);
        view.setText(activity.getCategories().get(pos).getParam2());
      }

      @Override
      public void onNothingSelected(AdapterView<?> adapter) {

      }
    });

    Spinner active = (Spinner) mContentView.findViewById(R.id.buy_active);
    List<Boolean> activeList = new ArrayList<Boolean>();
    activeList.add(oldDevice.isActive());
    activeList.add(!oldDevice.isActive());

    activeAdapter = new ArrayAdapter<Boolean>(getActivity(),
        android.R.layout.simple_spinner_item, activeList);
    activeAdapter
        .setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
    active.setAdapter(activeAdapter);

    int j = activeAdapter.getPosition(oldDevice.isActive());
    active.setSelection(j);

    active.setOnItemSelectedListener(new OnItemSelectedListener() {

      @Override
      public void onItemSelected(AdapterView<?> adapter, View view, int pos,
          long value) {
        newDevice.setActive((Boolean) adapter.getSelectedItem());

      }

      @Override
      public void onNothingSelected(AdapterView<?> adapter) {

      }
    });

    view = (EditText) mContentView.findViewById(R.id.buy_price);
    view.setText(oldDevice.getPrice().toString());
    view = (EditText) mContentView.findViewById(R.id.buy_title);
    view.setText(oldDevice.getTittle());
    view = (EditText) mContentView.findViewById(R.id.buy_param1);
    view.setText(oldDevice.getParam1().toString());
    view = (EditText) mContentView.findViewById(R.id.buy_param2);
    view.setText(oldDevice.getParam2());
    view = (EditText) mContentView.findViewById(R.id.buy_desc);
    view.setText(oldDevice.getDescription());

  }

  public void addOffer() {
    showDetails(null);

  }
}
