package com.wifioferta;

import java.util.ArrayList;
import java.util.List;

import com.wifioferta.R;


import android.app.ListFragment;
import android.content.Context;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
/*
* Fragment showing list of all user's buy offers
*/
public class BuyListFragment extends ListFragment {
  private View mContentView;
  private List<Buy> buy = new ArrayList<Buy>();

  @Override
  public void onActivityCreated(Bundle savedInstanceState) {
    super.onActivityCreated(savedInstanceState);
    OffersManagerActivity activity = (OffersManagerActivity) getActivity();
    buy = activity.getOffers().getBuys();
    this.setListAdapter(new BuyListAdapter(getActivity(), R.layout.row_buy, buy));
  }

  public void refreshList(List<Buy> buys) {
    buy = buys;
    this.setListAdapter(new BuyListAdapter(getActivity(), R.layout.row_buy, buy));
  }

  @Override
  public View onCreateView(LayoutInflater inflater, ViewGroup container,
      Bundle savedInstanceState) {
    mContentView = inflater.inflate(R.layout.buy_list, null);

    mContentView.findViewById(R.id.btn_add).setOnClickListener(
        new View.OnClickListener() {

          @Override
          public void onClick(View v) {
            ((BuyActionListener) getActivity()).addOffer();
          }
        });
    return mContentView;
  }

  @Override
  public void onListItemClick(ListView l, View v, int position, long id) {
    Buy device = (Buy) getListAdapter().getItem(position);
    ((BuyActionListener) getActivity()).showDetails(device);
  }

  private class BuyListAdapter extends ArrayAdapter<Buy> {

    private List<Buy> items;

    /**
     * @param context
     * @param textViewResourceId
     * @param objects
     */
    public BuyListAdapter(Context context, int textViewResourceId,
        List<Buy> objects) {
      super(context, textViewResourceId, objects);
      items = objects;

    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
      View v = convertView;
      if (v == null) {
        LayoutInflater vi = (LayoutInflater) getActivity().getSystemService(
            Context.LAYOUT_INFLATER_SERVICE);
        v = vi.inflate(R.layout.row_buy, null);
      }
      Buy device = items.get(position);
      if (device != null) {
        TextView top = (TextView) v.findViewById(R.id.device_name);
        if (top != null) {
          top.setText(device.getTittle());
        }
      }

      return v;

    }
  }

  public interface BuyActionListener {

    void showDetails(Buy device);

    void editOffer(Buy oldOffer, Buy newOffer);

    void deleteOffer(Buy device);

    void addOffer();

  }
}
