package com.wifioferta;


import java.io.Serializable;

import android.os.Parcel;
import android.os.Parcelable;
/*
* Category used to describe offers
*/
public class Category implements Parcelable, Serializable{

  private static final long serialVersionUID = -6059038343761951981L;
  private String name;
  private int id;
  private String param1;
  private String param2;
  private static int counter = 1;

  public Category(String name) {
    this.name = name;
    this.id = counter++;
    this.param1 = "";
    this.param2 = "";
  }
  
  public Category(String name, String par1, String par2) {
    this.name = name;
    this.id = counter++;
    this.param1 = par1;
    this.param2 = par2;
  }

  public Category(Parcel in) {
    name = in.readString();
    id = in.readInt();
    param1 = in.readString();
    param2 = in.readString();
    counter = in.readInt();
  }

  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public int getId() {
    return id;
  }

  public void setId(int id) {
    this.id = id;
  }


  public static final Parcelable.Creator<Category> CREATOR = new Parcelable.Creator<Category>() {
    public Category createFromParcel(Parcel in) {
     return new Category(in);
    }

    public Category[] newArray(int size) {
     return new Category[size];
    }
  };

  @Override
  public int describeContents() {
    return 0;
  }

  @Override
  public void writeToParcel(Parcel dest, int flags) {
    dest.writeString(name);
    dest.writeInt(id);
    dest.writeString(param1);
    dest.writeString(param2);
    dest.writeInt(counter);
    
  }


  public String getParam2() {
    return param2;
  }


  public void setParam2(String param2) {
    this.param2 = param2;
  }


  public String getParam1() {
    return param1;
  }


  public void setParam1(String param1) {
    this.param1 = param1;
  }

}
