package com.wifioferta;

import android.app.Fragment;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.net.wifi.WpsInfo;
import android.net.wifi.p2p.WifiP2pConfig;
import android.net.wifi.p2p.WifiP2pDevice;
import android.net.wifi.p2p.WifiP2pInfo;
import android.net.wifi.p2p.WifiP2pManager.ConnectionInfoListener;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;

import com.wifioferta.R;
import com.wifioferta.DeviceListFragment.DeviceActionListener;


/*
* Fragment showing user active sale offer
*/
public class DeviceDetailFragment extends Fragment implements
    ConnectionInfoListener {

  protected static final int CHOOSE_FILE_RESULT_CODE = 20;
  protected static final String CATEGORY = "Kategoria :";
  protected static final String TITLE = "Tytu :";
  protected static final String DESCRIPTION = "Opis :";
  protected static final String PRICE = "Cena :";
  private View mContentView = null;
  private WifiP2pDevice device;
  private WifiP2pInfo info;
  private static String send = "uno";
  private static String desc = "pusto";
  private static DeviceActionListener listener;
  ProgressDialog progressDialog = null;

  @Override
  public void onActivityCreated(Bundle savedInstanceState) {
    super.onActivityCreated(savedInstanceState);
  }

  @Override
  public View onCreateView(LayoutInflater inflater, ViewGroup container,
      Bundle savedInstanceState) {
    listener = ((DeviceActionListener) getActivity());
    mContentView = inflater.inflate(R.layout.device_detail, null);
    mContentView.findViewById(R.id.btn_connect).setOnClickListener(
        new View.OnClickListener() {
          @Override
          public void onClick(View v) {
            WifiP2pConfig config = new WifiP2pConfig();
            config.deviceAddress = device.deviceAddress;
            config.groupOwnerIntent = 15;
            config.wps.setup = WpsInfo.PBC;
            if (progressDialog != null && progressDialog.isShowing()) {
              progressDialog.dismiss();
            }
            progressDialog = ProgressDialog.show(getActivity(),
                "Press back to cancel", "Connecting to :"
                    + device.deviceAddress, true, true);
            ((DeviceActionListener) getActivity()).connect(config);

          }
        });

    mContentView.findViewById(R.id.btn_disconnect).setOnClickListener(
        new View.OnClickListener() {

          @Override
          public void onClick(View v) {
            ((DeviceActionListener) getActivity()).disconnect();
          }
        });

    mContentView.findViewById(R.id.btn_start_client).setOnClickListener(
        new View.OnClickListener() {

          @Override
          public void onClick(View v) {
            TextView statusText = (TextView) mContentView
                .findViewById(R.id.status_text);
            statusText.setText("Sending");
          }
        });

    return mContentView;
  }

  @Override
  public void onActivityResult(int requestCode, int resultCode, Intent data) {

    Uri uri = data.getData();
    Intent serviceIntent = new Intent(getActivity(), OfferTransferService.class);
    serviceIntent.setAction(OfferTransferService.ACTION_SEND_FILE);
    serviceIntent
        .putExtra(OfferTransferService.EXTRAS_FILE_PATH, uri.toString());
    serviceIntent.putExtra(OfferTransferService.EXTRAS_GROUP_OWNER_ADDRESS,
        info.groupOwnerAddress.getHostAddress());
    serviceIntent.putExtra(OfferTransferService.EXTRAS_GROUP_OWNER_PORT, 8988);
    getActivity().startService(serviceIntent);
  }

  @Override
  public void onConnectionInfoAvailable(final WifiP2pInfo info) {
    if (progressDialog != null && progressDialog.isShowing()) {
      progressDialog.dismiss();
    }
    this.info = info;
    this.getView().setVisibility(View.VISIBLE);

    // The owner IP is now known.
    TextView view = (TextView) mContentView.findViewById(R.id.group_owner);
    view.setText(getResources().getString(R.string.group_owner_text)
        + ((info.isGroupOwner == true) ? getResources().getString(R.string.yes)
            : getResources().getString(R.string.no)));

    // InetAddress from WifiP2pInfo struct.
    view = (TextView) mContentView.findViewById(R.id.device_info);
    view.setText("Group Owner IP - " + info.isGroupOwner
        + info.groupOwnerAddress.getHostAddress());
    if (info.groupFormed && info.isGroupOwner) {
      new FileServerAsyncTask(getActivity(),
          mContentView.findViewById(R.id.status_text)).execute();
    } else if (info.groupFormed) {
      Intent serviceIntent = new Intent(getActivity(),
          OfferTransferService.class);
      serviceIntent.setAction(OfferTransferService.ACTION_SEND_FILE);
      serviceIntent.putExtra(OfferTransferService.DESC, send);
      serviceIntent.putExtra(OfferTransferService.EXTRAS_GROUP_OWNER_ADDRESS,
          info.groupOwnerAddress.getHostAddress());
      serviceIntent.putExtra(OfferTransferService.EXTRAS_GROUP_OWNER_PORT, 8988);
      mContentView.findViewById(R.id.btn_connect).setVisibility(View.GONE);
      mContentView.findViewById(R.id.btn_disconnect).setVisibility(View.GONE);
      getActivity().startService(serviceIntent);
    }

    // hide the connect button
    mContentView.findViewById(R.id.btn_connect).setVisibility(View.GONE);
  }

  public void showDetails(WifiP2pDevice device) {
    this.device = device;
    this.getView().setVisibility(View.VISIBLE);
    TextView view = (TextView) mContentView.findViewById(R.id.device_address);
    view = (TextView) mContentView.findViewById(R.id.device_info);
    view.setText(desc);

  }

  public void sendDesc(String data) {
    send = data;
  }

  /**
   * Clears the UI fields after a disconnect or direct mode disable operation.
   */
  public void resetViews() {
    mContentView.findViewById(R.id.btn_connect).setVisibility(View.VISIBLE);
    TextView view = (TextView) mContentView.findViewById(R.id.device_address);
    view.setText(R.string.empty);
    view = (TextView) mContentView.findViewById(R.id.device_info);
    view.setText(R.string.empty);
    view = (TextView) mContentView.findViewById(R.id.group_owner);
    view.setText(R.string.empty);
    view = (TextView) mContentView.findViewById(R.id.status_text);
    view.setText(R.string.empty);
    mContentView.findViewById(R.id.btn_start_client).setVisibility(View.GONE);
    this.getView().setVisibility(View.GONE);
  }

  public static class FileServerAsyncTask extends AsyncTask<Void, Void, String> {

    private TextView statusText;

    /**
     * @param context
     * @param statusText
     */
    public FileServerAsyncTask(Context context, View statusText) {
      this.statusText = (TextView) statusText;
    }

    @Override
    protected String doInBackground(Void... params) {
      try { // receiving
        ServerSocket serverSocket = new ServerSocket(8988);
        Log.d(WiFiOfertaActivity.TAG, "Server: Socket opened");
        Socket client = serverSocket.accept();
        Log.d(WiFiOfertaActivity.TAG, "Server: connection done");
        InputStream is = client.getInputStream();
        OutputStream outputStream = client.getOutputStream();
        BufferedReader br = null;
        StringBuilder sb = new StringBuilder();

        String line;
        try {

          br = new BufferedReader(new InputStreamReader(is));
          while ((line = br.readLine()) != null) {
            sb.append(line);
          }

        } catch (IOException e) {
          e.printStackTrace();
        } finally {
          if (br != null) {
            try {
              br.close();
            } catch (IOException e) {
              e.printStackTrace();
            }
          }
        }

        String result = sb.toString();

        copyFile(is, outputStream);
        serverSocket.close();

        return result;
      } catch (IOException e) {
        Log.e(WiFiOfertaActivity.TAG, e.getMessage());
        return null;
      }
    }

    @Override
    protected void onPostExecute(String result) {
      desc = result;
      listener.disconnect();

    }

    @Override
    protected void onPreExecute() {
      statusText.setText("Opening a server socket");
    }

  }

  public static boolean copyFile(InputStream inputStream, OutputStream out) {
    byte buf[] = new byte[1024];
    int len;
    try {
      while ((len = inputStream.read(buf)) != -1) {
        out.write(buf, 0, len);

      }

      out.close();
      inputStream.close();
    } catch (IOException e) {
      Log.d(WiFiOfertaActivity.TAG, e.toString());
      return false;
    }
    return true;
  }

}
