package com.wifioferta;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import android.os.Parcel;
import android.os.Parcelable;
import android.util.Base64;

/*
* Offer which is extended by type sale or buy
*/
public class Offer implements Parcelable, Serializable {
  /**
   * 
   */
  private static final long serialVersionUID = 8288686553501321232L;
  private String title;
  private String description;
  private Double price;
  private Double param1;
  private String param2;
  private Category category;
  private String codedName;
  private boolean active;

  public Offer(String title, Double price, Double param1, String param2,
      Category category) {
    this.title = title;
    this.price = price;
    this.param1 = param1;
    this.param2 = param2;
    this.category = category;
    this.active = true;
    this.codedName = encrypt(category.getId(), param1, param2, price);
  }

  private String encrypt(int id, Double number, String sign, Double price) {
    String name = null;
    name = "+O/";
    name += id;
    name += ("+" + price + "+" + number + "/" + sign);
    String newName = encodeBase64(name);
    if (newName.length() <= 21)
      return newName;
    name = "+O/";
    name += id;
    name += ("+" + price + "+" + number);
    newName = encodeBase64(name);
    if (newName.length() <= 21)
      return newName;
    name = "+O/";
    name += id;
    name += ("+" + price + "/" + sign);
    newName = encodeBase64(name);
    if (newName.length() <= 21)
      return newName;
    name = "+O/";
    name += id;
    name += ("+" + price);
    newName = encodeBase64(name);
    if (newName.length() <= 21)
      return newName;
    name = "+O/";
    name += id;
    newName = encodeBase64(name);
    return newName;
  }

  public Boolean match(String deviceName, int id) {

    return false;
  }

  private String encodeBase64(String name) {
    byte[] bytesName = null;
    try {
      bytesName = name.getBytes("US-ASCII");
    } catch (UnsupportedEncodingException e1) {
      e1.printStackTrace();
    }
    String coded = null;
    coded = Base64.encodeToString(bytesName, 0);
    return coded;
  }

  public Offer() {
    title = "";
    price = 0.;
    description = "";
    param1 = 0.;
    param2 = "";
    category = new Category(" ");
    codedName = "";
    active = true;

  }

  public Offer(Parcel in) {
    title = in.readString();
    description = in.readString();
    price = in.readDouble();
    param1 = in.readDouble();
    param2 = in.readString();
    category = in.readParcelable(Category.class.getClassLoader());
    codedName = in.readString();
    active = (Boolean) in.readValue(boolean.class.getClassLoader());
  }

  public String getTittle() {
    return title;
  }

  public void setTittle(String tittle) {
    this.title = tittle;
  }



  public String getCodedName() {
    return codedName;
  }

  public void setCodedName() {
    codedName = encrypt(category.getId(), param1, param2, price);
  }

  public static final Parcelable.Creator<Offer> CREATOR = new Parcelable.Creator<Offer>() {
    public Offer createFromParcel(Parcel in) {
      return new Offer(in);
    }

    public Offer[] newArray(int size) {
      return new Offer[size];
    }
  };

  @Override
  public int describeContents() {
    return 0;
  }

  @Override
  public void writeToParcel(Parcel dest, int flags) {
    dest.writeString(title);
    dest.writeString(description);
    dest.writeDouble(price);
    dest.writeDouble(param1);
    dest.writeString(param2);
    dest.writeParcelable(category, flags);
    dest.writeString(codedName);
    dest.writeValue(active);

  }

  public Double getPrice() {
    return price;
  }

  public void setPrice(Double price) {
    this.price = price;
  }

  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public Category getCategory() {
    return category;
  }

  public void setCategory(Category category) {
    this.category = category;
  }

  public String getParam2() {
    return param2;
  }

  public void setParam2(String param2) {
    this.param2 = param2;
  }

  public Double getParam1() {
    return param1;
  }

  public boolean isActive() {
    return active;
  }

  public void setActive(boolean active) {
    this.active = active;
  }

  public void setParam1(Double param1) {
    this.param1 = param1;
  }

}
