package com.wifioferta;

import android.app.IntentService;
import android.content.Intent;
import android.util.Log;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetSocketAddress;
import java.net.Socket;

/*
 *Service to send offers to other devices
 */
public class OfferTransferService extends IntentService {

  private static final int SOCKET_TIMEOUT = 5000;
  public static final String ACTION_SEND_FILE = "com.wifioferta.SEND_FILE";
  public static final String EXTRAS_FILE_PATH = "file_url";
  public static final String DESC = "opis";
  public static final String EXTRAS_GROUP_OWNER_ADDRESS = "go_host";
  public static final String EXTRAS_GROUP_OWNER_PORT = "go_port";

  public OfferTransferService(String name) {
    super(name);
  }

  public OfferTransferService() {
    super("OfferTransferService");
  }

  @Override
  protected void onHandleIntent(Intent intent) {
    if (intent.getAction().equals(ACTION_SEND_FILE)) {
      String fileUri = intent.getExtras().getString(DESC);
      String host = intent.getExtras().getString(EXTRAS_GROUP_OWNER_ADDRESS);
      Socket socket = new Socket();
      int port = intent.getExtras().getInt(EXTRAS_GROUP_OWNER_PORT);
      try { // sending file
        Log.d(WiFiOfertaActivity.TAG, "Opening client socket - ");
        socket.bind(null);
        socket.connect((new InetSocketAddress(host, port)), SOCKET_TIMEOUT);

        Log.d(WiFiOfertaActivity.TAG, "Client socket - " + socket.isConnected());
        OutputStream stream = socket.getOutputStream();
       
        InputStream is = new ByteArrayInputStream(fileUri.getBytes("UTF-8"));
        DeviceDetailFragment.copyFile(is, stream);
      } catch (IOException e) {
        Log.e(WiFiOfertaActivity.TAG, e.getMessage());
      } finally {
        if (socket != null) {
          if (socket.isConnected()) {
            try {
              socket.close();
            } catch (IOException e) {
              // Give up
              e.printStackTrace();
            }
          }
        }
      }

    }
  }
}
