package com.wifioferta;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

import com.wifioferta.R;
import com.wifioferta.BuyListFragment.BuyActionListener;
import com.wifioferta.SellListFragment.SellActionListener;


import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.net.wifi.p2p.WifiP2pManager;
import android.net.wifi.p2p.WifiP2pManager.Channel;
import android.os.Bundle;

/*
*Activity allowing to manage all user's offers
*/

@SuppressLint("ValidFragment")
public class OffersManagerActivity extends Activity implements BuyActionListener,
    SellActionListener {
  private WifiP2pManager manager;
  private Channel channel;
  private Offers offers;
  private static List<Category> categories = new ArrayList<Category>() {
    private static final long serialVersionUID = 1L;
    {
      add(new Category("Telewizor", "Wielko", "Producent"));
      add(new Category("Samochd", "Rok produkcji", "Marka"));
    }
  };

  public void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);

    setContentView(R.layout.offer_manager);
    manager = (WifiP2pManager) getSystemService(Context.WIFI_P2P_SERVICE);
    channel = manager.initialize(this, getMainLooper(), null);

    Intent intent = getIntent();
    Bundle bundle = intent.getExtras();
    setOffers((Offers) bundle.getParcelable("offers"));
  }

  public void onResume() {
    super.onResume();
  }

  public void onPause() {
    super.onPause();
  }

  public void setName(String name) {

    Class<?> classToInvestigate = manager.getClass();

    try {
      Method[] aClassMethods = classToInvestigate.getDeclaredMethods();
      for (Method m : aClassMethods) {
        m.setAccessible(true);
        // When accessed directly to method application crashed
        if (m.getName().equals("setDeviceName")) {
          String deviceName = name;
          m.invoke(manager, channel, deviceName, null);
        }
      }
    } catch (IllegalAccessException e) {
      e.printStackTrace();
    } catch (IllegalArgumentException e) {
      e.printStackTrace();
    } catch (InvocationTargetException e) {
      e.printStackTrace();
    }
  }

  @Override
  public void showDetails(Buy offer) {
    BuyDetailFragment fragment = (BuyDetailFragment) getFragmentManager()
        .findFragmentById(R.id.buy_detail);
    fragment.showDetails(offer);

  }

  @Override
  public void addOffer() {
    BuyDetailFragment fragment = (BuyDetailFragment) getFragmentManager()
        .findFragmentById(R.id.buy_detail);
    fragment.addOffer();
  }

  public void editOffer(Buy oldOffer, Buy newOffer) {
    getOffers().getBuys().remove(oldOffer);
    getOffers().getBuys().add(newOffer);
    findViewById(R.id.buy_list).requestLayout();
    BuyListFragment fragment = (BuyListFragment) getFragmentManager()
        .findFragmentById(R.id.buy_list);
    fragment.refreshList(getOffers().getBuys());

    Intent intent1 = new Intent(this, WiFiOfertaActivity.class);
    Bundle bundle1 = new Bundle();
    bundle1.putParcelable("offers", getOffers());

    intent1.putExtras(bundle1);

    setResult(RESULT_OK, intent1);

  }

  public void deleteOffer(Buy offer) {
    getOffers().getBuys().remove(offer);
    findViewById(R.id.buy_list).requestLayout();
    BuyListFragment fragment = (BuyListFragment) getFragmentManager()
        .findFragmentById(R.id.buy_list);
    fragment.refreshList(getOffers().getBuys());
    Intent intent1 = new Intent(this, WiFiOfertaActivity.class);
    Bundle bundle1 = new Bundle();
    bundle1.putParcelable("offers", getOffers());

    intent1.putExtras(bundle1);

    setResult(RESULT_OK, intent1);
  }

  @Override
  public void showDetails(Sale offer) {
    SellDetailFragment fragment = (SellDetailFragment) getFragmentManager()
        .findFragmentById(R.id.sale_detail);
    fragment.showDetails(offer);

  }

  @Override
  public void addSaleOffer() {
    SellDetailFragment fragment = (SellDetailFragment) getFragmentManager()
        .findFragmentById(R.id.sale_detail);
    fragment.addSaleOffer();
  }

  public void editOffer(Sale oldOffer, Sale newOffer) {
    getOffers().getSales().remove(oldOffer);
    getOffers().getSales().add(newOffer);
    findViewById(R.id.sale_list).requestLayout();
    SellListFragment fragment = (SellListFragment) getFragmentManager()
        .findFragmentById(R.id.sale_list);
    fragment.refreshList(getOffers().getSales());

    Intent intent1 = new Intent(this, WiFiOfertaActivity.class);
    Bundle bundle1 = new Bundle();
    bundle1.putParcelable("offers", getOffers());

    intent1.putExtras(bundle1);

    setResult(RESULT_OK, intent1);

  }

  public void deleteOffer(Sale offer) {
    getOffers().getSales().remove(offer);
    findViewById(R.id.sale_list).requestLayout();
    SellListFragment fragment = (SellListFragment) getFragmentManager()
        .findFragmentById(R.id.sale_list);
    fragment.refreshList(getOffers().getSales());
    Intent intent1 = new Intent(this, WiFiOfertaActivity.class);
    Bundle bundle1 = new Bundle();
    bundle1.putParcelable("offers", getOffers());

    intent1.putExtras(bundle1);

    setResult(RESULT_OK, intent1);
  }

  public Offers getOffers() {
    return offers;
  }

  public void setOffers(Offers offers) {
    this.offers = offers;
  }

  public List<Category> getCategories() {
    return categories;
  }
}
