package com.wifioferta;

import java.util.ArrayList;
import java.util.List;

import android.app.IntentService;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.net.wifi.p2p.WifiP2pDevice;
import android.net.wifi.p2p.WifiP2pDeviceList;
import android.net.wifi.p2p.WifiP2pManager;
import android.net.wifi.p2p.WifiP2pManager.Channel;
import android.net.wifi.p2p.WifiP2pManager.PeerListListener;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.os.Messenger;
import android.os.RemoteException;
import android.util.Log;
import android.view.View;
import android.widget.Toast;
/*
* Service running in background 
* Searching for available devices
*/
public class PeersSearchService extends IntentService implements PeerListListener {
  private Boolean run = true;
  private Handler handler = new Handler();
  private Messenger messenger;
  private WifiP2pManager manager;
  private Channel channel;
  private List<WifiP2pDevice> peers = new ArrayList<WifiP2pDevice>();
  ProgressDialog progressDialog = null;
  View mContentView = null;
  public Handler messageHandler = new MessageHandler();

  public class MessageHandler extends Handler {
    @Override
    public void handleMessage(Message message) {
      int state = message.arg1;
      switch (state) {
        case 1:
          run = false;
          break;
        case 2:
          run = true;
          break;
      }
    }
  }

  public PeersSearchService() {
    super("PeersSearchService");
  }

  public IBinder onBind(Intent arg0) {
    return null;
  }

  @Override
  public void onDestroy() {
    run = false;
  }

  @Override
  protected void onHandleIntent(Intent intent) {
    Bundle extras = intent.getExtras();
    messenger = (Messenger) extras.get("MESSENGER");
    manager = (WifiP2pManager) getSystemService(Context.WIFI_P2P_SERVICE);
    channel = manager.initialize(this, getMainLooper(), null);
    run = true;

    ((Offers) extras.getParcelable("offers")).getBuys();
    while (run) {
      try {
        Thread.sleep(5000);
      } catch (InterruptedException e) {
        e.printStackTrace();
      }
      if (!run)
        break;
      handler.post(new Runnable() {
        public void run() {
          manager.discoverPeers(channel, new WifiP2pManager.ActionListener() {

            @Override
            public void onSuccess() {
            }

            @Override
            public void onFailure(int reasonCode) {
              Toast.makeText(getApplicationContext(),
                  "Discovery Failesd : " + reasonCode, Toast.LENGTH_SHORT)
                  .show();
            }
          });

        }
      });
    }

  }

  @Override
  public void onPeersAvailable(WifiP2pDeviceList peerList) {
    Log.d("PeersSearchService", "peers availble");
  }

  public void sendMessage() {
    Message message = Message.obtain();
    message.arg1 = 1;
    message.obj = peers;
    try {
      messenger.send(message);
    } catch (RemoteException e) {
      e.printStackTrace();
    }
  }

  
}
