package com.wifioferta;

import java.util.ArrayList;
import java.util.List;

import com.wifioferta.R;
import com.wifioferta.SellListFragment.SellActionListener;



import android.app.Fragment;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;

/*
* Fragment showing selected sale offer
* makes it possible to edit or delete
*/
public class SellDetailFragment extends Fragment {
  private View mContentView;
  private Sale oldDevice;
  private Sale newDevice;
  private ArrayAdapter<String> dataAdapter;
  private ArrayAdapter<Boolean> activeAdapter;

  /**
   * Updates the UI with device data
   * 
   * @param oldDevice
   *          the device to be displayed
   */
  @Override
  public void onActivityCreated(Bundle savedInstanceState) {
    super.onActivityCreated(savedInstanceState);
  }

  @Override
  public View onCreateView(LayoutInflater inflater, ViewGroup container,
      Bundle savedInstanceState) {

    mContentView = inflater.inflate(R.layout.sale_detail, null);

    mContentView.findViewById(R.id.btn_connect).setOnClickListener(
        new View.OnClickListener() {

          @Override
          public void onClick(View v) {

            if (newDevice == null) {
              newDevice = new Sale();
            }
            EditText view = (EditText) mContentView
                .findViewById(R.id.sale_price);
            try {
              newDevice.setPrice(Double.parseDouble(view.getText().toString()));
              view = (EditText) mContentView.findViewById(R.id.sale_param1);
              newDevice.setParam1(Double.parseDouble(view.getText().toString()));

            } catch (NumberFormatException e) {
            }
            view = (EditText) mContentView.findViewById(R.id.sale_param2);
            newDevice.setParam2(view.getText().toString());
            view = (EditText) mContentView.findViewById(R.id.sale_title);
            newDevice.setTittle(view.getText().toString());
            view = (EditText) mContentView.findViewById(R.id.sale_desc);
            newDevice.setDescription(view.getText().toString());
            newDevice.setCodedName();

            ((SellActionListener) getActivity())
                .editOffer(oldDevice, newDevice);
            mContentView.setVisibility(View.GONE);
          }
        });

    mContentView.findViewById(R.id.btn_disconnect).setOnClickListener(
        new View.OnClickListener() {

          @Override
          public void onClick(View v) {
            ((SellActionListener) getActivity()).deleteOffer(oldDevice);
            mContentView.setVisibility(View.GONE);
          }
        });

    return mContentView;
  }

  public void showDetails(Sale offer) {
    this.oldDevice = offer;
    this.newDevice = new Sale();
    this.getView().setVisibility(View.VISIBLE);
    if (oldDevice == null)
      oldDevice = new Sale();
    Spinner cat = (Spinner) mContentView.findViewById(R.id.sale_category);
    List<String> list = new ArrayList<String>();
    final OffersManagerActivity activity = (OffersManagerActivity) getActivity();
    for (Category category : activity.getCategories()) {
      list.add(category.getName());
    }

    dataAdapter = new ArrayAdapter<String>(getActivity(),
        android.R.layout.simple_spinner_item, list);
    dataAdapter
        .setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
    cat.setAdapter(dataAdapter);

    int i = dataAdapter.getPosition(oldDevice.getCategory().getName());
    cat.setSelection(i);
    cat.setOnItemSelectedListener(new OnItemSelectedListener() {
      @Override
      public void onItemSelected(AdapterView<?> adapter, View v, int pos,
          long value) {
        newDevice.setCategory(activity.getCategories().get(pos));
        TextView view = (TextView) mContentView.findViewById(R.id.sale_par1);
        view.setText(activity.getCategories().get(pos).getParam1());
        view = (TextView) mContentView.findViewById(R.id.sale_par2);
        view.setText(activity.getCategories().get(pos).getParam2());
      }

      @Override
      public void onNothingSelected(AdapterView<?> adapter) {

      }
    });
    if (i != 1)
      i = 0;
    Spinner active = (Spinner) mContentView.findViewById(R.id.sale_active);
    List<Boolean> activeList = new ArrayList<Boolean>();
    activeList.add(oldDevice.isActive());
    activeList.add(!oldDevice.isActive());

    activeAdapter = new ArrayAdapter<Boolean>(getActivity(),
        android.R.layout.simple_spinner_item, activeList);
    activeAdapter
        .setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
    active.setAdapter(activeAdapter);

    int j = activeAdapter.getPosition(oldDevice.isActive());
    active.setSelection(j);
    active.setOnItemSelectedListener(new OnItemSelectedListener() {

      @Override
      public void onItemSelected(AdapterView<?> adapter, View v, int pos,
          long value) {
        newDevice.setActive((Boolean) adapter.getSelectedItem());

      }

      @Override
      public void onNothingSelected(AdapterView<?> adapter) {

      }
    });
    TextView view = (TextView) mContentView.findViewById(R.id.sale_par1);
    view.setText(activity.getCategories().get(i).getParam1());
    view = (TextView) mContentView.findViewById(R.id.sale_par2);
    view.setText(activity.getCategories().get(i).getParam2());

    EditText inText = (EditText) mContentView.findViewById(R.id.sale_price);
    inText.setText(oldDevice.getPrice().toString());
    inText = (EditText) mContentView.findViewById(R.id.sale_title);
    inText.setText(oldDevice.getTittle());
    inText = (EditText) mContentView.findViewById(R.id.sale_param1);
    inText.setText(oldDevice.getParam1().toString());
    inText = (EditText) mContentView.findViewById(R.id.sale_param2);
    inText.setText(oldDevice.getParam2());
    inText = (EditText) mContentView.findViewById(R.id.sale_desc);
    inText.setText(oldDevice.getDescription());

  }

  public void addSaleOffer() {
    showDetails(null);
  }

}
