package com.wifioferta;

import java.util.ArrayList;
import java.util.List;

import com.wifioferta.R;


import android.app.ListFragment;
import android.content.Context;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;

/*
* Fragment showing list of all user's sale offers
*/
public class SellListFragment extends ListFragment {
  private View mContentView;
  private List<Sale> sale = new ArrayList<Sale>();

  @Override
  public void onActivityCreated(Bundle savedInstanceState) {
    super.onActivityCreated(savedInstanceState);
    OffersManagerActivity activity = (OffersManagerActivity) getActivity();
    sale = activity.getOffers().getSales();
    this.setListAdapter(new SellListAdapter(getActivity(), R.layout.row_sale,
        sale));
  }

  public void refreshList(List<Sale> sales) {
    sale = sales;
    boolean active = false;
    for (Sale s : sale) {
      if (s.isActive() && !active)
        active = true;
      else
        s.setActive(false);
    }
    this.setListAdapter(new SellListAdapter(getActivity(), R.layout.row_sale,
        sale));
  }

  @Override
  public View onCreateView(LayoutInflater inflater, ViewGroup container,
      Bundle savedInstanceState) {
    mContentView = inflater.inflate(R.layout.sale_list, null);

    mContentView.findViewById(R.id.btn_add).setOnClickListener(
        new View.OnClickListener() {

          @Override
          public void onClick(View v) {
            ((SellActionListener) getActivity()).addSaleOffer();
          }
        });
    return mContentView;
  }

  @Override
  public void onListItemClick(ListView l, View v, int position, long id) {
    Sale device = (Sale) getListAdapter().getItem(position);
    ((SellActionListener) getActivity()).showDetails(device);
  }

  private class SellListAdapter extends ArrayAdapter<Sale> {

    private List<Sale> items;

    /**
     * @param context
     * @param textViewResourceId
     * @param objects
     */
    public SellListAdapter(Context context, int textViewResourceId,
        List<Sale> objects) {
      super(context, textViewResourceId, objects);
      items = objects;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
      View v = convertView;
      if (v == null) {
        LayoutInflater vi = (LayoutInflater) getActivity().getSystemService(
            Context.LAYOUT_INFLATER_SERVICE);
        v = vi.inflate(R.layout.row_sale, null);
      }
      Sale device = items.get(position);
      if (device != null) {
        TextView top = (TextView) v.findViewById(R.id.device_name);
        if (top != null) {
          top.setText(device.getTittle());
        }
      }

      return v;

    }
  }

  public interface SellActionListener {

    void showDetails(Sale device);

    void editOffer(Sale oldOffer, Sale newOffer);

    void deleteOffer(Sale device);

    void addSaleOffer();
  }
}
